/* eslint-disable */
/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */
import { HTMLStencilElement, JSXBase } from "@stencil/core/internal";
import { FranchiseBackground } from "./components/mo-credit-card/constants/mo-credit-card.constants";
import { SlideDirection } from "./components/mo-side-modal/constants/mo-side-modal.constants";
import { MoTabBodyData, MoTabLabelData } from "./components/mo-tabs/constants/mo-tabs.interfaces";
import { TabsAlign } from "./components/mo-tabs/constants/mo-tabs.constants";
export namespace Components {
    interface MoCreditCard {
        /**
          * The credit card number. It can be a string or a number.
         */
        "cardNumber": string | number;
        /**
          * The title of the credit card.
         */
        "cardTitle": string;
        /**
          * The title for the current balance section.
         */
        "currentBalanceTitle": string;
        /**
          * The value of the current balance.
         */
        "currentBalanceValue": string;
        /**
          * A custom CSS class for styling the element.
         */
        "customClass": string;
        /**
          * Inline style of the element.
         */
        "customStyle": any | null | undefined;
        /**
          * The URL of the franchise icon.
         */
        "franchiseIconUrl": string;
        /**
          * The gradient background for the credit card. Use 'FranchiseBackground' enum values.
         */
        "gradientBackground": FranchiseBackground;
        /**
          * Specifies whether the credit card is disabled.
         */
        "isDisabled": boolean;
        /**
          * Determines whether the credit card is displayed in a small size.
         */
        "isSmall": boolean;
    }
    interface MoDummyButton {
        /**
          * The buttons label
         */
        "label": string;
    }
    interface MoSideModal {
        /**
          * Determines whether the modal can be closed by clicking outside of it.
         */
        "allowBackgroundClose": boolean;
        /**
          * A custom CSS class for styling the element.
         */
        "customClass": string;
        /**
          * Determines if the side modal is open or closed.
         */
        "isOpen": boolean;
        /**
          * Prop that sets the direction of the slide animation for the side modal.
          * @default 'right'
         */
        "slideDirection": SlideDirection;
    }
    interface MoTabBody {
        "getChild": () => Promise<MoTabBodyData>;
        /**
          * Body name must match with the label name.
         */
        "name": string;
    }
    interface MoTabLabel {
        /**
          * A custom CSS class for styling the element.
         */
        "customClass": string;
        /**
          * Inline style of the element.
         */
        "customStyle": any | null | undefined;
        /**
          * Method used from mo-tabs-group. Returns a promise that resolves to an object containing data about the MoTabLabel component.
          * @returns Promise<MoTabLabelData>
         */
        "getChild": () => Promise<MoTabLabelData>;
        /**
          * Label name must match with the body name.
         */
        "name": string;
    }
    interface MoTabs {
        /**
          * A custom CSS class for styling the element.
         */
        "customClass": string;
        /**
          * Inline style of the element.
         */
        "customStyle": any | null | undefined;
        /**
          * Determine the alignment of the tabs.
         */
        "tabsAlign": TabsAlign;
    }
    interface MyComponent {
        /**
          * The first name
         */
        "first": string;
        /**
          * The last name
         */
        "last": string;
        /**
          * The middle name
         */
        "middle": string;
    }
}
export interface MoSideModalCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLMoSideModalElement;
}
export interface MoTabLabelCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLMoTabLabelElement;
}
declare global {
    interface HTMLMoCreditCardElement extends Components.MoCreditCard, HTMLStencilElement {
    }
    var HTMLMoCreditCardElement: {
        prototype: HTMLMoCreditCardElement;
        new (): HTMLMoCreditCardElement;
    };
    interface HTMLMoDummyButtonElement extends Components.MoDummyButton, HTMLStencilElement {
    }
    var HTMLMoDummyButtonElement: {
        prototype: HTMLMoDummyButtonElement;
        new (): HTMLMoDummyButtonElement;
    };
    interface HTMLMoSideModalElement extends Components.MoSideModal, HTMLStencilElement {
    }
    var HTMLMoSideModalElement: {
        prototype: HTMLMoSideModalElement;
        new (): HTMLMoSideModalElement;
    };
    interface HTMLMoTabBodyElement extends Components.MoTabBody, HTMLStencilElement {
    }
    var HTMLMoTabBodyElement: {
        prototype: HTMLMoTabBodyElement;
        new (): HTMLMoTabBodyElement;
    };
    interface HTMLMoTabLabelElement extends Components.MoTabLabel, HTMLStencilElement {
    }
    var HTMLMoTabLabelElement: {
        prototype: HTMLMoTabLabelElement;
        new (): HTMLMoTabLabelElement;
    };
    interface HTMLMoTabsElement extends Components.MoTabs, HTMLStencilElement {
    }
    var HTMLMoTabsElement: {
        prototype: HTMLMoTabsElement;
        new (): HTMLMoTabsElement;
    };
    interface HTMLMyComponentElement extends Components.MyComponent, HTMLStencilElement {
    }
    var HTMLMyComponentElement: {
        prototype: HTMLMyComponentElement;
        new (): HTMLMyComponentElement;
    };
    interface HTMLElementTagNameMap {
        "mo-credit-card": HTMLMoCreditCardElement;
        "mo-dummy-button": HTMLMoDummyButtonElement;
        "mo-side-modal": HTMLMoSideModalElement;
        "mo-tab-body": HTMLMoTabBodyElement;
        "mo-tab-label": HTMLMoTabLabelElement;
        "mo-tabs": HTMLMoTabsElement;
        "my-component": HTMLMyComponentElement;
    }
}
declare namespace LocalJSX {
    interface MoCreditCard {
        /**
          * The credit card number. It can be a string or a number.
         */
        "cardNumber"?: string | number;
        /**
          * The title of the credit card.
         */
        "cardTitle"?: string;
        /**
          * The title for the current balance section.
         */
        "currentBalanceTitle"?: string;
        /**
          * The value of the current balance.
         */
        "currentBalanceValue"?: string;
        /**
          * A custom CSS class for styling the element.
         */
        "customClass"?: string;
        /**
          * Inline style of the element.
         */
        "customStyle"?: any | null | undefined;
        /**
          * The URL of the franchise icon.
         */
        "franchiseIconUrl"?: string;
        /**
          * The gradient background for the credit card. Use 'FranchiseBackground' enum values.
         */
        "gradientBackground"?: FranchiseBackground;
        /**
          * Specifies whether the credit card is disabled.
         */
        "isDisabled"?: boolean;
        /**
          * Determines whether the credit card is displayed in a small size.
         */
        "isSmall"?: boolean;
    }
    interface MoDummyButton {
        /**
          * The buttons label
         */
        "label"?: string;
    }
    interface MoSideModal {
        /**
          * Determines whether the modal can be closed by clicking outside of it.
         */
        "allowBackgroundClose"?: boolean;
        /**
          * A custom CSS class for styling the element.
         */
        "customClass"?: string;
        /**
          * Determines if the side modal is open or closed.
         */
        "isOpen"?: boolean;
        /**
          * Event emitted when the modal is closed.
         */
        "onCloseModal"?: (event: MoSideModalCustomEvent<any>) => void;
        /**
          * Prop that sets the direction of the slide animation for the side modal.
          * @default 'right'
         */
        "slideDirection"?: SlideDirection;
    }
    interface MoTabBody {
        /**
          * Body name must match with the label name.
         */
        "name"?: string;
    }
    interface MoTabLabel {
        /**
          * A custom CSS class for styling the element.
         */
        "customClass"?: string;
        /**
          * Inline style of the element.
         */
        "customStyle"?: any | null | undefined;
        /**
          * Label name must match with the body name.
         */
        "name"?: string;
        /**
          * Event emitted when the tab is selected.
         */
        "onSelectTab"?: (event: MoTabLabelCustomEvent<any>) => void;
    }
    interface MoTabs {
        /**
          * A custom CSS class for styling the element.
         */
        "customClass"?: string;
        /**
          * Inline style of the element.
         */
        "customStyle"?: any | null | undefined;
        /**
          * Determine the alignment of the tabs.
         */
        "tabsAlign"?: TabsAlign;
    }
    interface MyComponent {
        /**
          * The first name
         */
        "first"?: string;
        /**
          * The last name
         */
        "last"?: string;
        /**
          * The middle name
         */
        "middle"?: string;
    }
    interface IntrinsicElements {
        "mo-credit-card": MoCreditCard;
        "mo-dummy-button": MoDummyButton;
        "mo-side-modal": MoSideModal;
        "mo-tab-body": MoTabBody;
        "mo-tab-label": MoTabLabel;
        "mo-tabs": MoTabs;
        "my-component": MyComponent;
    }
}
export { LocalJSX as JSX };
declare module "@stencil/core" {
    export namespace JSX {
        interface IntrinsicElements {
            "mo-credit-card": LocalJSX.MoCreditCard & JSXBase.HTMLAttributes<HTMLMoCreditCardElement>;
            "mo-dummy-button": LocalJSX.MoDummyButton & JSXBase.HTMLAttributes<HTMLMoDummyButtonElement>;
            "mo-side-modal": LocalJSX.MoSideModal & JSXBase.HTMLAttributes<HTMLMoSideModalElement>;
            "mo-tab-body": LocalJSX.MoTabBody & JSXBase.HTMLAttributes<HTMLMoTabBodyElement>;
            "mo-tab-label": LocalJSX.MoTabLabel & JSXBase.HTMLAttributes<HTMLMoTabLabelElement>;
            "mo-tabs": LocalJSX.MoTabs & JSXBase.HTMLAttributes<HTMLMoTabsElement>;
            "my-component": LocalJSX.MyComponent & JSXBase.HTMLAttributes<HTMLMyComponentElement>;
        }
    }
}
